{# Template for CA config file #}
{{ ansible_managed | comment }}

## Root Certificate Authority Root Configuration File.

## MAIN ########################################################################

[ openssl_conf_section ]
alg_section = evp_sect

[ evp_sect ]
fips_mode = {{ 'yes' if certificate_authority_config_fips | bool else 'no' }}

[ ca ]
default_ca = root_ca

## CA ##########################################################################

[ root_ca ]
dir               = {{ certificate_authority_config_dir }}/g{{ generation }}/root
certs             = $dir/certs
certificate       = $dir/certs/root.crt
private_key       = $dir/private/root.key
new_certs_dir     = $dir/signed
default_days      = {{ certificate_authority_config_root_signing_validity if not certificate_authority_settings_simple else certificate_authority_config_cert_validity }}
default_md        = {{ certificate_authority_config_root_signing_algorithm if not certificate_authority_settings_simple else certificate_authority_config_inti_signing_algorithm }}
database          = $dir/data/index
serial            = $dir/data/serial
RANDFILE          = $dir/data/rand
{# crl               = $dir/crl/root.crl #}
{# crl_dir           = $dir/crl #}
{# default_crl_days  = {{ certificate_authority_config_root_signing_crl_days }} #}
{# crlnumber         = $dir/data/crl_serial #}
{# crl_extensions    = crl_ext #}
name_opt          = ca_default
cert_opt          = ca_default
preserve          = no
policy            = ca_policy
copy_extensions   = copy

## POLICY ######################################################################

[ ca_policy ]
countryName             = {{ certificate_authority_config_policy_country }}
stateOrProvinceName     = {{ certificate_authority_config_policy_state }}
localityName            = {{ certificate_authority_config_policy_locality }}
organizationName        = {{ certificate_authority_config_policy_organization }}
emailAddress            = {{ certificate_authority_config_policy_email }}
commonName              = supplied

## REQUESTS ####################################################################

[ req ]
default_bits        = {{ certificate_authority_config_root_key_bits if not certificate_authority_settings_simple else certificate_authority_config_inti_signing_key_bits }}
default_md          = {{ certificate_authority_config_root_signing_algorithm if not certificate_authority_settings_simple else certificate_authority_config_inti_signing_algorithm }}
distinguished_name  = req_distinguished_name
string_mask         = utf8only
x509_extensions     = {{ 'v3_intermediate_ca' if not certificate_authority_settings_simple else 'server_cert' }}

[ req_distinguished_name ]
countryName                     = Country Name (2 letter code)
stateOrProvinceName             = State or Province Name
localityName                    = Locality Name
0.organizationName              = Organization Name
commonName                      = Common Name
emailAddress                    = Email Address

countryName_default             = {{ certificate_authority_config_subject_country }}
stateOrProvinceName_default     = {{ certificate_authority_config_subject_state }}
localityName_default            = {{ certificate_authority_config_subject_locality }}
0.organizationName_default      = {{ certificate_authority_config_subject_organization }}
emailAddress_default            = {{ certificate_authority_config_subject_email }}

## X509 CA #####################################################################

[ v3_root_ca ]
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid:always,issuer
basicConstraints = critical, CA:true
keyUsage = critical, digitalSignature, cRLSign, keyCertSign

{% if not certificate_authority_settings_simple %}
[ v3_inti_ca ]
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid:always,issuer
basicConstraints = critical, CA:true, pathlen:0
keyUsage = critical, digitalSignature, cRLSign, keyCertSign

[ v3_intermediate_ca ]
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid:always,issuer
basicConstraints = critical, CA:true, pathlen:{{ certificate_authority_config_root_signing_pathlen }}
keyUsage = critical, digitalSignature, cRLSign, keyCertSign
{% else %}
[ server_cert ]
basicConstraints = CA:FALSE
nsCertType = server
nsComment = “{{ certificate_authority_config_name | default(certificate_authority_config_subject_organization,true) }} Server Certificate”
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer:always
keyUsage = critical, digitalSignature, keyEncipherment
extendedKeyUsage = serverAuth

[ usr_cert ]
basicConstraints = CA:FALSE
nsCertType = client, email
nsComment = “{{ certificate_authority_config_name | default(certificate_authority_config_subject_organization,true) }} Client Certificate”
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer
keyUsage = critical, nonRepudiation, digitalSignature, keyEncipherment
extendedKeyUsage = clientAuth, emailProtection
{% endif %}
{#
## CRL & OCSP ##################################################################

[ crl_ext ]
authorityKeyIdentifier=keyid:always
crlDistributionPoints = URI:http://example.com/crl.pem

[ ocsp ]
basicConstraints = CA:FALSE
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer
keyUsage = critical, digitalSignature
extendedKeyUsage = critical, OCSPSigning
authorityInfoAccess = OCSP;URI:http://ocsp.example.com, CAIssuers;URI:http://example.com/root-ca.pem
#}
